import matplotlib.pyplot as plt
import plotly.graph_objects as go
import plotly.express as px
import numpy as np
import pandas as pd
import os

def npload(path):
	try: a = np.load(path)
	except: a = np.zeros(256)/0
	return np.concatenate((a, np.tile(a[-1], 256-len(a))))

# for l in sorted(os.listdir("baobab/activations/images-autoenc-cnn/")):
# 	a = npload(f"baobab/activations/loss/{l}-diverse-kernels.np.npy")
# 	print(f"{a.shape}{l}")

# df = pd.DataFrame({
# 	l: np.log(npload(f"baobab/activations/loss/{l}-diverse-kernels.np.npy"))
# 	# f"{l}-c": "red"
# 	for l in sorted(os.listdir("baobab/activations/images-autoenc-cnn/"))
# })

# px.line(df,log_x=True,color="red").show()

def csscol(rgba):
	if rgba is None: return None
	if len(rgba)==4: return f"rgba({rgba[0]*255},{rgba[1]*255},{rgba[2]*255},{rgba[3]})"
	if len(rgba)==3: return f"rgb({rgba[0]*255},{rgba[1]*255},{rgba[2]*255})"

fig = go.Figure()
for name in sorted(os.listdir("baobab/activations/images-autoenc-cnn/")):
	y = np.log(npload(f"baobab/activations/loss/{name}-diverse-kernels.np.npy"))
	rgba = None
	if name=="identity"     : rgba = [1,0,0]
	if name[:4]=="sin("     : rgba = np.array([1,.5,0])*(0.5+0.5*np.random.rand(1))
	if name[:6]=="perlin"   : rgba = np.array([0, 1,1])*(0.5+0.5*np.random.rand(1))
	if name=="CELU"         : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="ELU"          : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="GELU"         : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name[:9]=="LeakyReLU": rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="PReLU"        : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="RReLU"        : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="ReLU"         : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="ReLU6"        : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="SELU"         : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="SiLU"         : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="Mish"         : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="Softplus"     : rgba = np.array([0,.6,0])*(0.5+0.5*np.random.rand(1))
	if name=="Hardsigmoid"  : rgba = [.4,0,.4]
	if name=="sigmoid"      : rgba = [.4,0,.4]
	if name[:5]=="multi": rgba = [1,.5,.5]
	if name[:5]=="x+ax²": rgba = [.5,.5,.5]
	if not rgba is None:
		rgba = list(rgba) + [.5]
	color = csscol(rgba)
	fig.add_trace(go.Scatter(y=y, name=name, line=dict(color=color, width=1)))

fig.update_layout(
	xaxis_title='epoch',
	yaxis_title='log(loss)',
	xaxis=dict(type='log'),
)
fig.show()

# Hardshrink
# Hardswish
# Hardtanh
# LogSigmoid
# LogSoftmax

# Softmax
# Softmin
# Softshrink
# Softsign
# Tanh
# Tanhshrink
# abs
# atan
# cantor
# cantor2
# identity
# sinc(x)
# tan















# fig = go.Figure()
# for i in range(10):
# 	y = np.random.randn(128)
# 	# fig.add_trace(go.Scatter(y=y, name=f"name-{i}", mode='lines'))
# 	fig.add_trace(go.Scatter(y=y, name=f"name-{i}", line=dict(color=csscol([i/10,0,0]))))

# fig.show()

# fig.update_layout(
# 	# xaxis_title='False Positive Rate',
# 	# yaxis_title='True Positive Rate',
# 	# yaxis=dict(scaleanchor="x", scaleratio=1),
# 	# xaxis=dict(constrain='domain'),
# 	# width=700, height=500
# )
# fig.show()
